
library IEEE;
use IEEE.Std_logic_1164.all;
use IEEE.Numeric_Std.all;

entity ENCODER1_tb is
end;

architecture bench of ENCODER1_tb is

  component ENCODER1 
  PORT (
          clk     : in std_logic;
          nRST    : in std_logic;
          data_l  : in std_logic;
          data_r  : in std_logic;
          out_l   : out std_logic;
          out_r   : out std_logic
        );
   end component;

  signal clk: std_logic;
  signal nRST: std_logic;
  signal data_l: std_logic;
  signal data_r: std_logic;
  signal out_l: std_logic;
  signal out_r: std_logic ;

  constant clock_period: time := 10 ns;
  signal stop_the_clock: boolean;

begin

  uut: ENCODER1 port map ( clk    => clk,
                           nRST   => nRST,
                           data_l => data_l,
                           data_r => data_r,
                           out_l  => out_l,
                           out_r  => out_r );

  stimulus: process
  begin
  
    -- Put initialisation code here

    nRST <= '0';
    wait for 10 ns;
    nRST <= '1';
    wait for 10 ns;

    -- Put test bench stimulus code here
    data_L <= '0';
    wait for 20ns;
    data_L <= '1';
    wait for 20ns;    
    data_L <= '0';
    wait for 20ns;    
    data_L <= '1';
    wait for 20ns;    
    data_L <= '0';
    wait for 20ns;
    data_L <= '0';
    wait for 20ns; 
    data_L <= '1';
    wait for 20ns;  
    data_L <= '1';
    wait for 20ns;
    data_R <= '0';
    data_L <= '0';
    wait for 20ns;
    data_R <= '0';
    data_L <= '0';
    wait for 20ns;    
    data_R <= '1';
    data_L <= '0';
    wait for 20ns;
    data_R <= '0';
    data_L <= '1';
    wait for 20ns;
     

    stop_the_clock <= true;
    wait;
  end process;

  clocking: process
  begin
    while not stop_the_clock loop
      clk <= '1', '0' after clock_period / 2;
      wait for clock_period;
    end loop;
    wait;
  end process;

end;